import { HardhatRuntimeEnvironment } from "hardhat/types";
import { DeployFunction } from "hardhat-deploy/types";
import { updateArray } from "../scripts/utils"

const deployNFTForGame: DeployFunction = 
  async function (hre: HardhatRuntimeEnvironment) {
    const provider = hre.ethers.provider;
    const from = await (await provider.getSigner()).getAddress();
    const ret = await hre.deployments.deploy("TestSlot", {
      from,
      args: ['0xd948549711a1f1198851e8eb8b4857a6159c6388bbab253fbc5b0160b0f9cd5d'],
      log: true,
    });
    console.log("==TestSlot addr=", ret.address);
    
  };

  deployNFTForGame.tags = ["TestSlot"];

export default deployNFTForGame;
